#include <avr/io.h>
#include "ATmega88PA.h"
#include "display.h"
#include "usart.h"
#include "rtc.h"
#include "ir.h"
#include "app_urt.h"

/* Remote control display */

static uint8_t column = 0;

static void URT_DataReceived(uint8_t data) {
    if(data == 0xFE) {
        DISPLAY_Clear();
    } else if(data >= 0xE0) {
        column = data & 0x1F;
    } else if(data >= 0x80 && column <= 0x14) {
        DISPLAY_Print((data & 0x7F), column);
    } else if(data < 0x80 && column <= 0x18) {
        DISPLAY_Column(data, column);
    }
}

static void URT_Tick(void) {
    DISPLAY_CheckBrightness();
}

void URT_Init(void) {
    IR_Activate();
    USART_BAUD_RATE_115200;
    USART_Setup_8N1();
    USART_Activate();
    USART_DataReceived = URT_DataReceived;
    RTC_Tick = URT_Tick;
    DISPLAY_Clear();
    DISPLAY_Print(_U_,  4);
    DISPLAY_Print(_R_, 10);
    DISPLAY_Print(_T_, 16);
}
